commit 74f54ee8117404303dd67b8e6fa860c38efdbab6
Author: Marc Dequènes (Duck) <Duck@DuckCorp.org>
Date:   Thu Oct 22 23:51:22 2009 +0200

    [fix] added missing start of YAML document in MP shadow config files

diff --git a/conf/ldap_shadows/shadows/MilkyPond/aspects/fs.conf b/conf/ldap_shadows/shadows/MilkyPond/aspects/fs.conf
index b20e98f..9fc17a7 100644
--- a/conf/ldap_shadows/shadows/MilkyPond/aspects/fs.conf
+++ b/conf/ldap_shadows/shadows/MilkyPond/aspects/fs.conf
@@ -1,3 +1,4 @@
+---
 mapping:
   classes: ['fsUser']
 presentation:
diff --git a/conf/ldap_shadows/shadows/MilkyPond/aspects/ftp.conf b/conf/ldap_shadows/shadows/MilkyPond/aspects/ftp.conf
index f0542a2..606d985 100644
--- a/conf/ldap_shadows/shadows/MilkyPond/aspects/ftp.conf
+++ b/conf/ldap_shadows/shadows/MilkyPond/aspects/ftp.conf
@@ -1,3 +1,4 @@
+---
 mapping:
   classes: ['ftpUser']
   depend_aspects: ['primary', 'fs']
diff --git a/conf/ldap_shadows/shadows/MilkyPond/aspects/jabber.conf b/conf/ldap_shadows/shadows/MilkyPond/aspects/jabber.conf
index 388af61..a9e969d 100644
--- a/conf/ldap_shadows/shadows/MilkyPond/aspects/jabber.conf
+++ b/conf/ldap_shadows/shadows/MilkyPond/aspects/jabber.conf
@@ -1,2 +1,3 @@
+---
 mapping:
   classes: ['jabberUser']
diff --git a/conf/ldap_shadows/shadows/MilkyPond/aspects/mail.conf b/conf/ldap_shadows/shadows/MilkyPond/aspects/mail.conf
index df7261e..7a027af 100644
--- a/conf/ldap_shadows/shadows/MilkyPond/aspects/mail.conf
+++ b/conf/ldap_shadows/shadows/MilkyPond/aspects/mail.conf
@@ -1,2 +1,3 @@
+---
 mapping:
   classes: ['emailUser']
diff --git a/conf/ldap_shadows/shadows/MilkyPond/aspects/primary.conf b/conf/ldap_shadows/shadows/MilkyPond/aspects/primary.conf
index a5cc429..8d652a8 100644
--- a/conf/ldap_shadows/shadows/MilkyPond/aspects/primary.conf
+++ b/conf/ldap_shadows/shadows/MilkyPond/aspects/primary.conf
@@ -1,3 +1,4 @@
+---
 mapping:
   classes: ['primaryAccount']
 presentation:
diff --git a/conf/ldap_shadows/shadows/MilkyPond/aspects/shell.conf b/conf/ldap_shadows/shadows/MilkyPond/aspects/shell.conf
index ae83e20..5299105 100644
--- a/conf/ldap_shadows/shadows/MilkyPond/aspects/shell.conf
+++ b/conf/ldap_shadows/shadows/MilkyPond/aspects/shell.conf
@@ -1,3 +1,4 @@
+---
 mapping:
   classes: ['shellUser']
   depend_aspects: ['primary', 'fs']
diff --git a/conf/ldap_shadows/shadows/MilkyPond/aspects/web.conf b/conf/ldap_shadows/shadows/MilkyPond/aspects/web.conf
index 8e43779..7006fbf 100644
--- a/conf/ldap_shadows/shadows/MilkyPond/aspects/web.conf
+++ b/conf/ldap_shadows/shadows/MilkyPond/aspects/web.conf
@@ -1,3 +1,4 @@
+---
 mapping:
   classes: ['webUser']
   depend_aspects: ['primary']
diff --git a/conf/ldap_shadows/shadows/MilkyPond/objects/bot.conf b/conf/ldap_shadows/shadows/MilkyPond/objects/bot.conf
index ffc10b0..9f484a9 100644
--- a/conf/ldap_shadows/shadows/MilkyPond/objects/bot.conf
+++ b/conf/ldap_shadows/shadows/MilkyPond/objects/bot.conf
@@ -1,3 +1,4 @@
+---
 mapping:
   dn_attribute: uid
   prefix: ''
diff --git a/conf/ldap_shadows/shadows/MilkyPond/objects/domain.conf b/conf/ldap_shadows/shadows/MilkyPond/objects/domain.conf
index 5034883..05e5e2e 100644
--- a/conf/ldap_shadows/shadows/MilkyPond/objects/domain.conf
+++ b/conf/ldap_shadows/shadows/MilkyPond/objects/domain.conf
@@ -1,3 +1,4 @@
+---
 mapping:
   dn_attribute: cn
   prefix: ''
diff --git a/conf/ldap_shadows/shadows/MilkyPond/objects/entity.conf b/conf/ldap_shadows/shadows/MilkyPond/objects/entity.conf
index b6d740e..56b4dac 100644
--- a/conf/ldap_shadows/shadows/MilkyPond/objects/entity.conf
+++ b/conf/ldap_shadows/shadows/MilkyPond/objects/entity.conf
@@ -1,3 +1,4 @@
+---
 mapping:
   dn_attribute: o
   prefix: ''
diff --git a/conf/ldap_shadows/shadows/MilkyPond/objects/group.conf b/conf/ldap_shadows/shadows/MilkyPond/objects/group.conf
index 57462d0..5ea6a13 100644
--- a/conf/ldap_shadows/shadows/MilkyPond/objects/group.conf
+++ b/conf/ldap_shadows/shadows/MilkyPond/objects/group.conf
@@ -1,3 +1,4 @@
+---
 mapping:
   dn_attribute: cn
   prefix: ''
diff --git a/conf/ldap_shadows/shadows/MilkyPond/objects/individual.conf b/conf/ldap_shadows/shadows/MilkyPond/objects/individual.conf
index bd35d9e..ae744b0 100644
--- a/conf/ldap_shadows/shadows/MilkyPond/objects/individual.conf
+++ b/conf/ldap_shadows/shadows/MilkyPond/objects/individual.conf
@@ -1,3 +1,4 @@
+---
 mapping:
   dn_attribute: uid
   prefix: ''
diff --git a/conf/ldap_shadows/shadows/MilkyPond/objects/secondary_account.conf b/conf/ldap_shadows/shadows/MilkyPond/objects/secondary_account.conf
index c7bb48a..a5c9cb8 100644
--- a/conf/ldap_shadows/shadows/MilkyPond/objects/secondary_account.conf
+++ b/conf/ldap_shadows/shadows/MilkyPond/objects/secondary_account.conf
@@ -1,3 +1,4 @@
+---
 mapping:
   dn_attribute: uid
   prefix: ''
diff --git a/conf/ldap_shadows/shadows/MilkyPond/objects/system_account.conf b/conf/ldap_shadows/shadows/MilkyPond/objects/system_account.conf
index 3cf103d..ce25a5f 100644
--- a/conf/ldap_shadows/shadows/MilkyPond/objects/system_account.conf
+++ b/conf/ldap_shadows/shadows/MilkyPond/objects/system_account.conf
@@ -1,3 +1,4 @@
+---
 mapping:
   dn_attribute: uid
   prefix: ''
diff --git a/conf/ldap_shadows/shadows/MilkyPond/objects/unit.conf b/conf/ldap_shadows/shadows/MilkyPond/objects/unit.conf
index bf03083..9de9245 100644
--- a/conf/ldap_shadows/shadows/MilkyPond/objects/unit.conf
+++ b/conf/ldap_shadows/shadows/MilkyPond/objects/unit.conf
@@ -1,3 +1,4 @@
+---
 mapping:
   dn_attribute: ou
   prefix: ''